--- cdr_addon_mysql.c	Wed Oct 17 03:09:26 2007
+++ cdr_addon_mysql.c	Fri Oct 26 17:49:20 2007
@@ -124,6 +124,9 @@
 #ifdef MYSQL_LOGUNIQUEID
 	char *uniqueid = NULL;
 #endif
+#if MYSQL_VERSION_ID >= 50013
+	my_bool my_bool_true = 1;
+#endif
 
 	ast_mutex_lock(&mysql_lock);
 
@@ -140,6 +143,12 @@
 		if (timeout && mysql_options(&mysql, MYSQL_OPT_CONNECT_TIMEOUT, (char *)&timeout)!=0) {
 			ast_log(LOG_ERROR, "cdr_mysql: mysql_options returned (%d) %s\n", mysql_errno(&mysql), mysql_error(&mysql));
 		}
+#if MYSQL_VERSION_ID >= 50013
+		/* Add option for automatic reconnection */
+		if (mysql_options(&mysql, MYSQL_OPT_RECONNECT, &my_bool_true)!=0) {
+			ast_log(LOG_ERROR, "cdr_mysql: mysql_options returned (%d) %s\n", mysql_errno(&mysql), mysql_error(&mysql));
+		}
+#endif
 		if (mysql_real_connect(&mysql, hostname, dbuser, password, dbname, dbport, dbsock, 0)) {
 			connected = 1;
 			connect_time = time(NULL);
@@ -296,6 +305,9 @@
 	struct ast_config *cfg;
 	struct ast_variable *var;
 	const char *tmp;
+#if MYSQL_VERSION_ID >= 50013
+	my_bool my_bool_true = 1;
+#endif
 
 	cfg = ast_config_load(config);
 	if (!cfg) {
@@ -441,6 +453,13 @@
 	if (timeout && mysql_options(&mysql, MYSQL_OPT_CONNECT_TIMEOUT, (char *)&timeout)!=0) {
 		ast_log(LOG_ERROR, "cdr_mysql: mysql_options returned (%d) %s\n", mysql_errno(&mysql), mysql_error(&mysql));
 	}
+
+#if MYSQL_VERSION_ID >= 50013
+	/* Add option for automatic reconnection */
+	if (mysql_options(&mysql, MYSQL_OPT_RECONNECT, &my_bool_true)!=0) {
+		ast_log(LOG_ERROR, "cdr_mysql: mysql_options returned (%d) %s\n", mysql_errno(&mysql), mysql_error(&mysql));
+	}
+#endif
 
 	if (!mysql_real_connect(&mysql, hostname, dbuser, password, dbname, dbport, dbsock, 0)) {
 		ast_log(LOG_ERROR, "Failed to connect to mysql database %s on %s.\n", dbname, hostname);
